diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/include/of1275.h linuxppc_2_4_devel-local/arch/ppc/boot/include/of1275.h
--- linuxppc_2_4_devel-dup/arch/ppc/boot/include/of1275.h	Mon Sep  9 18:17:46 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/include/of1275.h	Mon Sep  9 11:05:43 2002
@@ -29,6 +29,9 @@
 int	read(ihandle instance, void *buf, int buflen);
 void	release(void *virt, unsigned int size);
 int	write(ihandle instance, void *buf, int buflen);
+ihandle	open(const char *name);
+void	close(ihandle instance);
+int	setcolor(ihandle instance, int color, int red, int green, int blue);
 
 /* inlines */
 
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/Makefile linuxppc_2_4_devel-local/arch/ppc/boot/of1275/Makefile
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/Makefile	Mon Sep  9 18:17:46 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/Makefile	Sun Sep  8 15:00:07 2002
@@ -5,6 +5,6 @@
 L_TARGET := of1275.a
 
 obj-y := claim.o enter.o exit.o finddevice.o getprop.o ofinit.o	\
-	 ofstdio.o read.o release.o write.o
+	 ofstdio.o read.o release.o write.o open.o close.o setcolor.o
 
 include $(TOPDIR)/Rules.make
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/claim.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/claim.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/claim.c	Mon Sep  9 18:17:46 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/claim.c	Sun Sep  8 15:07:39 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/claim.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/close.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/close.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/close.c	Thu Jan  1 01:00:00 1970
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/close.c	Mon Sep  9 11:01:53 2002
@@ -0,0 +1,27 @@
+/*
+ * Copyright (C) Leigh Brown 2002.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version
+ * 2 of the License, or (at your option) any later version.
+ */
+
+#include "of1275.h"
+
+void
+close(ihandle instance)
+{
+    struct prom_args {
+	char *service;
+	int nargs;
+	int nret;
+	ihandle instance;
+    } args;
+
+    args.service = "close";
+    args.nargs = 1;
+    args.nret = 0;
+    args.instance = instance;
+    (*of_prom_entry)(&args);
+}
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/enter.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/enter.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/enter.c	Mon Sep  9 18:17:46 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/enter.c	Sun Sep  8 15:07:49 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/enter.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/exit.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/exit.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/exit.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/exit.c	Sun Sep  8 15:07:58 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/exit.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/finddevice.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/finddevice.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/finddevice.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/finddevice.c	Sun Sep  8 15:08:05 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/finddevice.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/getprop.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/getprop.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/getprop.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/getprop.c	Sun Sep  8 15:08:15 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/getprop.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/ofinit.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/ofinit.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/ofinit.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/ofinit.c	Sun Sep  8 15:08:24 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/ofinit.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/ofstdio.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/ofstdio.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/ofstdio.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/ofstdio.c	Sun Sep  8 15:08:34 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/ofstdio.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/open.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/open.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/open.c	Thu Jan  1 01:00:00 1970
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/open.c	Mon Sep  9 11:01:44 2002
@@ -0,0 +1,30 @@
+/*
+ * Copyright (C) Leigh Brown 2002.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version
+ * 2 of the License, or (at your option) any later version.
+ */
+
+#include "of1275.h"
+
+ihandle
+open(const char *name)
+{
+    struct prom_args {
+	char *service;
+	int nargs;
+	int nret;
+	const char *name;
+	ihandle instance;
+    } args;
+
+    args.service = "open";
+    args.nargs = 1;
+    args.nret = 1;
+    args.name = name;
+    args.instance = OF_INVALID_HANDLE;
+    (*of_prom_entry)(&args);
+    return args.instance;
+}
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/read.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/read.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/read.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/read.c	Sun Sep  8 15:08:40 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/read.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/release.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/release.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/release.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/release.c	Sun Sep  8 15:08:46 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/release.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/setcolor.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/setcolor.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/setcolor.c	Thu Jan  1 01:00:00 1970
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/setcolor.c	Sun Sep  8 15:08:53 2002
@@ -0,0 +1,42 @@
+/*
+ * arch/ppc/boot/of1275/setcolor.c
+ *
+ * Copyright (C) Leigh Brown 2002.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version
+ * 2 of the License, or (at your option) any later version.
+ */
+
+#include "of1275.h"
+
+int
+setcolor(ihandle instance, int color, int red, int green, int blue)
+{
+    struct prom_args {
+	char *service;
+	int nargs;
+	int nret;
+	char *method;
+	ihandle instance;
+	int color;
+	int blue;
+	int green;
+	int red;
+	int result;
+    } args;
+
+    args.service = "call-method";
+    args.nargs = 6;
+    args.nret = 1;
+    args.method = "color!";
+    args.instance = instance;
+    args.color = color;
+    args.blue = blue;
+    args.green = green;
+    args.red = red;
+    args.result = 0;
+    (*of_prom_entry)(&args);
+    return args.result;
+}
diff -urNX /home/leigh/.diffex linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/write.c linuxppc_2_4_devel-local/arch/ppc/boot/of1275/write.c
--- linuxppc_2_4_devel-dup/arch/ppc/boot/of1275/write.c	Mon Sep  9 18:17:47 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/of1275/write.c	Sun Sep  8 15:09:02 2002
@@ -1,4 +1,6 @@
 /*
+ * arch/ppc/boot/of1275/write.c
+ *
  * Copyright (C) Paul Mackerras 1997.
  * Copyright (C) Leigh Brown 2002.
  *
